Index: python/FlexpartTools.py
===================================================================
--- python/FlexpartTools.py	(revision 9e660c47faa9ca2b9e19d5da43ad0027c730a960)
+++ python/FlexpartTools.py	(revision d69b6776d6d39e0af0d38c95cbfd78284c9866e4)
@@ -410,244 +383,147 @@
     xbd[mask]=xb[mask]*xc[mask]/(xb[mask]+xd[mask])
     sfeld=xac+xbd
-
+    
     return sfeld
-
-def add_previousday_ifneeded(attrs):
-
-    if attrs['type']=='FC' and 'acc' not in attrs['target']:
-        steps=attrs['step'].split('/')
-        times=attrs['time'].split('/')
-        addpday=False
-        #for t in times:
-            #for s in steps:
-        if int(times[0])+int(steps[0])>23:
-            addpday=True
-        if(addpday):
-            dates=attrs['date'].split('/')
-            start_date=dates[0]
-            syear=int(start_date[:4])
-            smonth=int(start_date[4:6])
-            sday=int(start_date[6:])
-            start = datetime.date( year = syear, month = smonth, day = sday )
-            startm1=start- datetime.timedelta(days=1)
-
-            attrs['date']='/'.join([startm1.strftime("%Y%m%d")]+dates[1:])
-            print('CHANGED FC start date to '+startm1.strftime("%Y%m%d")+'to accomodate TIME='+times[0]+', STEP='+steps[0])
-
-    return
-
-
-
+    
 class Control:
-    'class containing the information of the flex_extract control file'
-
+    'class containing the information of the ECMWFDATA control file'
+    
     def __init__(self,filename):
-
-        #try:
-        with open(filename) as f:
-            fdata = f.read().split('\n')
-            for ldata in fdata:
-                data=ldata.split()
-                if len(data)>1:
-                    if 'm_' in data[0].lower():
-                        data[0]=data[0][2:]
-                    if data[0].lower()=='class':
-                        data[0]='marsclass'
-                    if data[0].lower()=='day1':
-                        data[0]='start_date'
-                    if data[0].lower()=='day2':
-                        data[0]='end_date'
-                    if data[0].lower()=='addpar':
-                        if '/' in data[1]:
-                            if data[1][0]=='/':
-                                data[1]=data[1][1:]
-                            dd=data[1].split('/')
-                            data=[data[0]]
-                            for d in dd:
-                                data.append(d)
-                        pass
-                    if len(data)==2:
-                        if '$' in data[1]:
+	
+	#try:
+	    with open(filename) as f:
+		fdata = f.read().split('\n')
+		for ldata in fdata:
+		    data=ldata.split()
+		    if len(data)>1:
+			if 'm_' in data[0].lower():
+			    data[0]=data[0][2:]
+			if data[0].lower()=='class':
+			    data[0]='marsclass'
+			if data[0].lower()=='day1':
+			    data[0]='start_date'
+			if data[0].lower()=='day2':
+			    data[0]='end_date'
+			if data[0].lower()=='addpar':
+			    if '/' in data[1]:
+				if data[1][0]=='/':
+				    data[1]=data[1][1:]
+				dd=data[1].split('/')
+				data=[data[0]]
+				for d in dd:
+				    data.append(d)
+			    pass
+			if len(data)==2:
+			    if '$' in data[1]:
 #				print data[1]
-                            setattr(self,data[0].lower(),data[1])
-                            while '$' in data[1]:
-                                i=data[1].index('$')
-                                j=data[1].find('{')
-                                k=data[1].find('}')
-                                var=os.getenv(data[1][j+1:k])
-                                if var is not None:
-                                    data[1]=data[1][:i]+var+data[1][k+1:]
-                                else:
-                                    myerror(None,'Could not find variable '+data[1][j+1:k]+' while reading '+filename)
-
+				setattr(self,data[0].lower(),data[1])				
+				while '$' in data[1]:
+				    i=data[1].index('$')
+				    j=data[1].find('{')
+				    k=data[1].find('}')
+				    var=os.getenv(data[1][j+1:k])
+				    if var is not None:
+					data[1]=data[1][:i]+var+data[1][k+1:]
+				    else:
+					myerror(None,'Could not find variable '+data[1][j+1:k]+' while reading '+filename)
+					
 #				    print data[0],data[1]
-                            setattr(self,data[0].lower()+'_expanded',data[1])
-                        else:
-                            if data[1].lower()!='none':
-                                setattr(self,data[0].lower(),data[1])
-                            else:
-                                setattr(self,data[0].lower(),None)
-
-                    elif len(data)>2:
-                        setattr(self,data[0].lower(),(data[1:]))
-                else:
-                    pass
-
-            if not hasattr(self,'start_date'):
-                self.start_date=None
-            if not hasattr(self,'end_date'):
-                self.end_date=self.start_date
-            if not hasattr(self,'accuracy'):
-                self.accuracy=24
-            if not hasattr(self,'omega'):
-                self.omega='0'
-            if not hasattr(self,'cwc'):
-                self.cwc='0'
-            if not hasattr(self,'omegadiff'):
-                self.omegadiff='0'
-            if not hasattr(self,'etadiff'):
-                self.etadiff='0'
-
-            if not hasattr(self,'addpar'):
-                self.addpar=''
-            if not isinstance(self.type, list):
-                self.type = [self.type]
-            if not isinstance(self.time, list):
-                self.time = [self.time]
-            if not isinstance(self.step, list):
-                self.step = [self.step]
-
-            max_level_list = [16, 19, 31, 40, 50, 60, 62, 91, 137]
-            if not hasattr(self,'levelist'):
-                if not hasattr(self,'level'):
-                    print 'WARNING: neither levelist nor level specified in CONTROL file'
-                else:
-                    if self.level in max_level_list:
-                        self.levelist='1/to/'+self.level
-            else:
-                if not hasattr(self, 'level'):
-                    if 'to' in self.levelist.lower():
-                        max_level = self.levelist.split('/')[2]
-                        if int(max_level) in max_level_list:
-                            self.level = max_level
-                        else:
-                            print 'ERROR: LEVEL-parameter could not be set'
-                            print 'LEVEL must be the maximum level of a specified level list from ECMWF, e.g.'
-                            print '16, 19, 31, 40, 50, 60, 62, 91 or 137'
-                            sys.exit(1)
-                    else:
-                        max_level = self.levelist.split('/')[-1]
-                        if int(max_level) in max_level_list:
-                            self.level = max_level
-                        else:
-                            print 'ERROR: LEVEL-parameter could not be set'
-                            print 'LEVEL must be the maximum level of a specified level list from ECMWF, e.g.'
-                            print '16, 19, 31, 40, 50, 60, 62, 91 or 137'
-                            sys.exit(1)
-                else:
-                    # check if consistent
-                    if int(self.level) in max_level_list:
-                        pass
-                    else:
-                        print 'ERROR: LEVEL-parameter is not properly selected'
-                        print 'LEVEL must be the maximum level of a specified level list from ECMWF, e.g.'
-                        print '16, 19, 31, 40, 50, 60, 62, 91 or 137'
-                        sys.exit(1)
-
-            if not hasattr(self,'maxstep'):
-                self.maxstep=0
-                for s in self.step:
-                    if int(s)>self.maxstep:
-                        self.maxstep=int(s)
-            else:
-                self.maxstep=int(self.maxstep)
-            if not hasattr(self,'prefix'):
-                self.prefix='EN'
-            if not hasattr(self,'makefile'):
-                self.makefile=None
-            if not hasattr(self,'basetime'):
-                self.basetime=None
-            if not hasattr(self,'date_chunk'):
-                self.date_chunk='3'
-
-            self.flexextractdir=os.path.dirname(os.path.abspath(inspect.getfile(inspect.currentframe())))+'/../' # script directory
+				setattr(self,data[0].lower()+'_expanded',data[1])				
+			    else:
+				if data[1].lower()!='none': 
+				    setattr(self,data[0].lower(),data[1])
+				else:
+				    setattr(self,data[0].lower(),None)
+				    
+			elif len(data)>2:
+			    setattr(self,data[0].lower(),(data[1:]))
+		    else:
+			pass
+		    
+		if not hasattr(self,'start_date'):
+		    self.start_date=None
+		if not hasattr(self,'end_date'):
+		    self.end_date=self.start_date
+		if not hasattr(self,'accuracy'):
+		    self.accuracy=24
+		if not hasattr(self,'omega'):
+		    self.omega='0'
+		if not hasattr(self,'cwc'):
+		    self.cwc='0'
+		if not hasattr(self,'omegadiff'):
+		    self.omegadiff='0'
+		if not hasattr(self,'etadiff'):
+		    self.etadiff='0'
+		if not hasattr(self,'levelist'):
+		    if not hasattr(self,'level'):
+			print 'Warning: neither levelist nor level specified in CONTROL file'	
+		    else:
+			self.levelist='1/to/'+self.level
+		else:
+		    if 'to' in self.levelist:
+			self.level=self.levelist.split('/')[2]
+		    else:
+			self.level=self.levelist.split('/')[-1]
+		    
+		if not hasattr(self,'maxstep'):
+		    self.maxstep=0
+		    for s in self.step:
+			if int(s)>self.maxstep:
+			    self.maxstep=int(s)
+		else:
+		    self.maxstep=int(self.maxstep)
+		if not hasattr(self,'prefix'):
+		    self.prefix='EN'
+		if not hasattr(self,'makefile'):
+		    self.makefile=None
+		if not hasattr(self,'basetime'):
+		    self.basetime=None
+		if not hasattr(self,'date_chunk'):
+		    self.date_chunk='3'
+		    
+		self.ecmwfdatadir=os.path.dirname(os.path.abspath(inspect.getfile(inspect.currentframe())))+'/../' # script directory
 #		if not hasattr(self,'exedir'):
-            self.exedir=self.flexextractdir+'src/'
-            if not hasattr(self,'grib2flexpart'):
-                self.grib2flexpart='0'
-            if not hasattr(self,'flexpart_root_scripts'):
-                self.flexpart_root_scripts=self.flexextractdir
-
-            if not hasattr(self,'acctype'):
-                print('... Control paramter ACCTYPE was not defined in CONTROL file.')
-                print('Important for (forecast) flux data extraction.')
-                try:
-                    if len(self.type) > 1 and self.type[1] != 'AN':
-                        print('Use old setting by using TYPE[1].')
-                        self.acctype = self.type[1]
-                except:
-                    print('Use default value "FC"!')
-                    self.acctype='FC'
-
-            if not hasattr(self,'acctime'):
-                print('... Control paramter ACCTIME was not defined in CONTROL file.')
-                print('Use default value "00/12" for flux forecast!')
-                print('This may be different for single data sets, see documentation if retrieval fails!')
-                self.acctime='00/12'
-
-            if not hasattr(self, 'accmaxstep'):
-                print('... Control paramter ACCMAXSTEP was not defined in CONTROL file.')
-                print('Use default value "12" for flux forecast!')
-                print('This may be different for single data sets, see documentation if retrieval fails!')
-                self.accmaxstep='12'
-
-            for i in range(len(self.type)):
-                if self.type[i] == 'AN' and int(self.step[i]) != 0:
-                    print('Analysis retrievals must have STEP = 0 (setting to 0)')
-                    self.type[i] = 0
-
-            if not hasattr(self,'request'):
-                self.request=0
-            elif int(self.request) != 0:
-                self.request=int(self.request)
-                marsfile = os.path.join(self.inputdir,
-                                        'mars_requests.csv')
-                if os.path.isfile(marsfile):
-                    silentremove(marsfile)
-
-        return
+  	        self.exedir=self.ecmwfdatadir+'src/'
+		if not hasattr(self,'grib2flexpart'):
+		    self.grib2flexpart='0'
+		if not hasattr(self,'flexpart_root_scripts'):
+		    self.flexpart_root_scripts=self.ecmwfdatadir
+		
+	    
+
+	    return
     def __str__(self):
-
-        attrs = vars(self)
-        # {'kids': 0, 'name': 'Dog', 'color': 'Spotted', 'age': 10, 'legs': 2, 'smell': 'Alot'}
-        # now dump this in some way or another
-        return ', '.join("%s: %s" % item for item in attrs.items())
-
+	
+	attrs = vars(self)
+	# {'kids': 0, 'name': 'Dog', 'color': 'Spotted', 'age': 10, 'legs': 2, 'smell': 'Alot'}
+	# now dump this in some way or another
+	return ', '.join("%s: %s" % item for item in attrs.items())
+    
     def tolist(self):
-        attrs=vars(self)
-        l=list()
-        for item in attrs.items():
-            if '_expanded' in item[0]:
-                pass
-            elif 'exedir' in item[0]:
-                pass
-            elif 'flexpart_root_scripts' in item[0]:
-                pass
-            elif 'flexextractdir' in item[0]:
-                pass
-
-            else:
-                if type(item[1]) is list:
-                    stot=''
-                    for s in item[1]:
-                        stot+=s+' '
-
-                    l.append("%s %s" % (item[0],stot))
-                else:
-                    l.append("%s %s" % item )
-        return sorted(l)
-
-
-
+	attrs=vars(self)
+	l=list()
+	for item in attrs.items():
+	    if '_expanded' in item[0]:
+		pass
+	    elif 'exedir' in item[0]:
+		pass
+	    elif 'flexpart_root_scripts' in item[0]:
+		pass
+	    elif 'ecmwfdatadir' in item[0]:
+		pass
+	    
+	    else:
+		if type(item[1]) is list:
+		    stot=''
+		    for s in item[1]:
+			stot+=s+' '
+			
+		    l.append("%s %s" % (item[0],stot))
+		else:
+		    l.append("%s %s" % item )
+	return sorted(l)
+    
+    
+	
 ##############################################################
 # MARSretrieval class
@@ -656,8 +532,8 @@
     'class for MARS retrievals'
 
-    def __init__(self,server, public, marsclass="ei",type="",levtype="",levelist="",
+    def __init__(self,server, marsclass="ei",type="",levtype="",levelist="", 
                  repres="", date="",resol="",stream="",area="",time="",step="",expver="1",
                  number="",accuracy="", grid="", gaussian="", target="",param="",dataset="",expect=""):
-        self.dataset=dataset
+#        self.dataset=dataset
         self.marsclass=marsclass
         self.type=type
@@ -680,113 +556,57 @@
 #	self.expect=expect
         self.server=server
-        self.public=public
 
     def displayInfo(self):
-        attrs=vars(self)
-        for item in attrs.items():
-            if item[0] in ('server'):
-                pass
-            else:
-                print item[0]+': '+str(item[1])
-
-        return
-
-    def print_infodata_csv(self, inputdir, request_number):
-        '''
-        @Description:
-            Write all request parameter in alpabetical order into a "csv" file.
-
-        @Input:
-            self: instance of MarsRetrieval
-                For description see class documentation.
-
-            inputdir: string
-                The path where all data from the retrievals are stored.
-
-            request_number: integer
-                Number of mars requests for flux and non-flux data.
-
-        @Return:
-            <nothing>
-        '''
-
-        # Get all class attributes and their values as a dictionary
-        attrs = vars(self).copy()
-        del attrs['server']
-        del attrs['public']
-
-        # open a file to store all requests to
-        with open(os.path.join(inputdir, 'mars_requests.csv'), 'a') as f:
-            f.write(str(request_number) + ', ')
-            f.write(', '.join(str(attrs[key])
-                        for key in sorted(attrs.iterkeys())))
-            f.write('\n')
-
-        return
+	attrs=vars(self)
+	for item in attrs.items():
+	    if item[0] in ('server'):
+		pass
+	    else:
+		print item[0]+': '+str(item[1])
+	
+	return
 
     def dataRetrieve(self):
-        attrs=vars(self).copy()
-
-        del attrs['server']
-        del attrs['public']
-        mclass = attrs.get('marsclass')
-        del attrs['marsclass']
-        attrs['class'] = mclass
-
-        add_previousday_ifneeded(attrs)
-
-        target = attrs.get('target')
-        if not int(self.public):
-            del attrs['target']
-        print 'target: ', target
-
-        delete_keys = []
-        for k, v in attrs.iteritems():
-            if v == '':
-                delete_keys.append(str(k))
-            else:
-                attrs[k] = str(v)
-
-        for k in delete_keys:
-            del attrs[k]
+	attrs=vars(self)
+
+#        self.server.retrieve(dicolist)
+	s='ret'
+        for k,v in attrs.iteritems():
+	    if k in ('server'):
+		continue
+            if k=='marsclass':
+                k='class'
+	    if v=='':
+		continue
+	    if k.lower()=='target':
+		target=v
+	    else:
+		s=s+','+k+'='+str(v)
 
         if self.server != False:
-            try:
-                if int(self.public):
-                    print 'RETRIEVE DATA!'
-                    self.server.retrieve(attrs)
-                else:
-                    print 'EXECUTE RETRIEVAL!'
-                    self.server.execute(attrs, target)
-            except:
-                e = sys.exc_info()[0]
-                print "Error: ", e
-                print 'MARS Request failed'#, have you already registered at apps.ecmwf.int?'
-                #raise IOError
-            if not int(self.public) and os.stat(target).st_size==0:
-                print 'MARS Request returned no data - please check request'
-                raise IOError
-            elif int(self.public) and os.stat(attrs.get('target')).st_size==0:
-                print 'MARS Request returned no data - please check request'
-                raise IOError
+	    try:
+		self.server.execute(s,target)
+	    except:
+		print 'MARS Request failed, have you already registered at apps.ecmwf.int?'
+		raise IOError
+	    if os.stat(target).st_size==0:
+		print 'MARS Request returned no data - please check request'
+		raise IOError
         else:
-            s='ret'
-            for k,v in attrs.iteritems():
-                s=s+','+k+'='+str(v)
-
+            
             s+=',target="'+target+'"'
             p=subprocess.Popen(['mars'], stdin=subprocess.PIPE, stdout=subprocess.PIPE, stderr=subprocess.PIPE,bufsize=1)
             pout=p.communicate(input=s)[0]
             print pout.decode()
-            if 'Some errors reported' in pout.decode():
-                print 'MARS Request failed - please check request'
-                raise IOError
-
-            if os.stat(target).st_size==0:
-                print 'MARS Request returned no data - please check request'
-                raise IOError
-
-        return
-
+	    if 'Some errors reported' in pout.decode():
+		print 'MARS Request failed - please check request'
+		raise IOError
+	    
+	    if os.stat(target).st_size==0:
+		print 'MARS Request returned no data - please check request'
+		raise IOError
+	    
+	return
+            
 ##############################################################
 class EIFlexpart:
